/*
 *	File:					MyRequest().h
 *	Description:	Displays a text in different requesters
 *
 *	(C) 1993, Ketil Hunn
 *
 */

#include "MyEZRequest().h"

#ifndef MYREQUEST_H
#define MYREQUEST_H

extern short reqType;

#define INTUITION_TYPE	0
#define REQTOOLS_TYPE		1
#define MUI_TYPE				3

long MyRequest(char *format, char *buttons, char *param)
{
	extern APTR app, window;
	LONG retvalue;

	switch(reqType)
	{

#ifdef LIBRARIES_REQTOOLS_H
		case REQTOOLS_TYPE:
			if(ReqToolsBase)
				retvalue=rtEZRequest(format, buttons, NULL, NULL, param);
			else if(IntuitionBase)
				retvalue=MyEZRequest(title, format, buttons, param);
			break;
#endif

#ifdef LIBRARIES_MUI_H
		case MUI_TYPE:
			if(MUIMasterBase)
				retvalue=MUI_Request(app, window, 0, NULL, buttons, format, param);
			else if(IntuitionBase)
				retvalue=MyEZRequest(title, format, buttons, param);
			break;
#endif

		default:
			if(IntuitionBase)
				retvalue=MyEZRequest(title, format, buttons, param);
			break;
	}
	return retvalue;
}
#endif
